// game.h
unsigned char host_x, host_y;

void init_malos () {
	struct sp_Rect rectangulo;
	char i, j;
	char num_torretas;
	char veces = 0;
	char encontrado;
	
	for (i = 0; i < 5; i ++) {
		malos [i].tipo = 0;
		malos [i].vida = 0;
		malos [i].update = 0;
		malos [i].x = 240;
	}
	
	// Aqu selecciono los cuatro malos por pantalla
	num_torretas = 1 + (rand () & 3);
	
	for (i = 0; i < num_torretas; i ++) {
		malos [i].tipo = 1;
		
		// Hacemos "caer" desde arriba para calcular la coordenada y
		// Para no estar infinitamente aqu (cuando no sea posible ubicar)
		// se sale si se ha intentado 7 veces.
		do {
			malos [i].x = ((rand () % 7) << 5) + 8;		
			malos [i].y = 0;
			while (malos [i].y < 160 && cur_pant_buf [((malos [i].y >> 5) << 3) + (malos [i].x >> 5)] >= 41) {
				malos [i].y += 32;
			} 
			
			encontrado = 0;
			for (j = 0; j < i; j ++) {
				if (malos [i].x == malos [j].x) {
					encontrado = 1;
				}
			}
			
			if (!encontrado && malos [i].y != 160 && malos [i].y != 0) {
				malos [i].y -= 16;
				break;	
			}
			
			veces ++;
		} while (veces < 7);
		
		if (malos [i].y != 0 && malos [i].y != 160 && veces < 7) {
			malos [i].vida = 5;
			malos [i].frame = 1;
			malos [i].ct = 0;
			malos [i].oldx = malos [i].x;
			malos [i].oldy = malos [i].y;
			// salvamos buffer
			rectangulo.height = rectangulo.width = 2;
			rectangulo.row_coord = Y_OFFSET + (malos [i].y >> 3);
			rectangulo.col_coord = X_OFFSET + (malos [i].x >> 3);
			sp_GetTiles (&rectangulo, flyingbads_buffer + (i << 3));
		} else {
			malos [i].vida = 0;
			malos [i].tipo = 2;			
		}
	}
	
	for (i = num_torretas; i < 4; i ++) {
		// Los enemigos voladores se crean al vuelo constantemente, pero
		// hay que definirles el tipo:
		malos [i].vida = 0;
		malos [i].tipo = 2;	
	}
	
	// rollerfirer (enemigo namber for)
	/*
	if ((rand () & 127) < 91) {
		malos [4].x = (rand () % 25) << 3;
		malos [4].y = 0;
		malos [4].oldx = malos [4].x;
		malos [4].oldy = malos [4].y;
		malos [4].vx = malos [4].vy = 0;
		malos [4].vida = 10 + (rand () & 7);
		malos [4].frame = 1;
		malos [4].ct = 0;
		
		// salvamos buffer
		rectangulo.height = rectangulo.width = 3;
		rectangulo.row_coord = Y_OFFSET + (malos [4].y >> 3);
		rectangulo.col_coord = X_OFFSET + (malos [4].x >> 3);
		sp_GetTiles (&rectangulo, rollerfirer_buffer);
	}
	*/
}

void move_malos () {
	char i, j, o;
	struct sp_Rect rectangulo;
	unsigned char cx, cy, xx, yy;
	
	for (i = 0; i < 4; i ++) {
		switch ( malos [i].tipo ) {
			case 1:
				if (malos [i].vida > 0 ) {
					o = malos [i].frame; 
					
					if (helmet.x > malos [i].x)
						malos [i].frame = 0;
					else
						malos [i].frame = 1;
						
					if (o != malos [i].frame) {
						csp2_Draw_2x2_Sprite (malos [i].x >> 3, malos [i].y >> 3, malos [i].frame);	
					}
						
					malos [i].ct = (malos [i].ct + 1) & 7;
					
					// Disparar:
					if (helmet.status) {
						if (malos [i].ct == 0 && helmet.y >= malos [i].y - 24 && helmet.y <= malos [i].y + 16) {
							if (malos [i].frame)	// izquierda
								add_particle (malos [i].x - 8, malos [i].y + 8, -8, 0, 1, 1);
							else					// derecha
								add_particle (malos [i].x + 16, malos [i].y + 8, 8, 0, 1, 1);
						}
					}
				}				
				break;
			case 2:
				malos [i].ct2 = (malos [i].ct2 + 1) & 31;				
				if (malos [i].vida == 0) {
					// Vemos si creamos uno nuevo:
					if ( (rand () & 31) == 0) {
						
						do {
							malos [i].x = (rand () % 25) << 3;
							malos [i].y = (rand () % 10) << 3;
													
							cx = malos [i].x >> 3;
							cy = malos [i].y >> 3;
							xx = malos [i].x >> 5;
							yy = malos [i].y >> 5;
							
							if ((cy & 3) == 3) {
								if ((cx & 3) == 3) {
									o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
										cur_pant_buf [(yy<<3) + xx + 1] < 41 ||
										cur_pant_buf [((yy + 1)<<3) + xx] < 41 ||
										cur_pant_buf [((yy + 1)<<3) + xx + 1] < 41);
								} else {
									o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
										cur_pant_buf [((yy + 1)<<3) + xx] < 41);
								}
							} else {
								if ((cx & 3) == 3) {
									o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
										cur_pant_buf [(yy<<3) + xx + 1] < 41);
								} else {
									o = (cur_pant_buf [(yy<<3) + xx] < 41);
								}	
							}
						} while (o);
						
						malos [i].oldx = malos [i].x;
						malos [i].oldy = malos [i].y;
						malos [i].vida = 5;
						malos [i].status = 5;
						malos [i].ct = 10;
						malos [i].ct2 = rand () & 15;
						malos [i].basesp = (rand () & 1) * 2 + 2;
						malos [i].frame = malos [i].basesp;
						// salvamos buffer
						for (j = 0; j < 4; j ++) 
							if (j != i && malos [j].tipo == 2 && malos [j].vida > 0) {		
								rectangulo.height = rectangulo.width = 2;
								rectangulo.row_coord = Y_OFFSET + (malos [j].y >> 3);
								rectangulo.col_coord = X_OFFSET + (malos [j].x >> 3);
								sp_PutTiles (&rectangulo, flyingbads_buffer + (j << 3));
								sp_Invalidate (&rectangulo, &rectangulo);
							}
						rectangulo.height = rectangulo.width = 2;
						rectangulo.row_coord = Y_OFFSET + (malos [i].y >> 3);
						rectangulo.col_coord = X_OFFSET + (malos [i].x >> 3);
						sp_GetTiles (&rectangulo, flyingbads_buffer + (i << 3));
					}	
				} else {
					malos [i].frame = malos [i].basesp + (rand () & 1);
					
					if (malos [i].status == 0) {					
						// Estado 0 = seleccionar nuevo estado (direccin).
						
						if ((rand () & 3) == 0) {
							malos [i].status = (rand () & 3) + 1;	// 1, 2, 3 o 4
							malos [i].ct = rand () & 7;				// Avanza hasta 8
							malos [i].size = 1 << (rand () & 3);
						}
					} else {
						
						switch (malos [i].status) {
							case 1:	
								// Arriba
								if (malos [i].y >= 8)
									malos [i].y -= malos [i].size;
								else {
									malos [i].status = 0;
									malos [i].y = 8;
								}
								break;
							case 2:
								// Abajo
								if (malos [i].y <= 128)
									malos [i].y += malos [i].size;
								else {
									malos [i].status = 0;
									malos [i].y = 128;
								}
								break;
							case 3:
								// Izquierda
								if (malos [i].x >= 8)
									malos [i].x -= malos [i].size;
								else {
									malos [i].status = 0;
									malos [i].x = 8;
								}
								break;
							case 4:
								// Derecha
								if (malos [i].x <= 192)
									malos [i].x += malos [i].size;
								else {
									malos [i].status = 0;
									malos [i].x = 192;
								}
								break;
							case 5:
								// Apareciendo
								malos [i].frame = 6 + (rand () & 1);
						}
						
						// Undo? Esto es cutre, pero ocupa poco y me vale.
						
						cx = malos [i].x >> 3;
						cy = malos [i].y >> 3;
						xx = malos [i].x >> 5;
						yy = malos [i].y >> 5;
						o = 0;
						
						if ((cy & 3) == 3) {
							if ((cx & 3) == 3) {
								o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
									cur_pant_buf [(yy<<3) + xx + 1] < 41 ||
									cur_pant_buf [((yy + 1)<<3) + xx] < 41 ||
									cur_pant_buf [((yy + 1)<<3) + xx + 1] < 41);
							} else {
								o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
									cur_pant_buf [((yy + 1)<<3) + xx] < 41);
							}
						} else {
							if ((cx & 3) == 3) {
								o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
									cur_pant_buf [(yy<<3) + xx + 1] < 41);
							} 
						}
						
						if (o) {
							malos [i].x = malos [i].oldx;
							malos [i].y = malos [i].oldy;
						}
						
						if (malos [i].ct > 0) 
							malos [i].ct --;
						else
							malos [i].status = 0;
					}
					
					// Disparar:
					if (malos [i].ct2 == 0 && helmet.status) {
						if (malos [i].x < helmet.x) {
							if (malos [i].y < helmet.y) {
								add_particle (malos [i].x + 16, malos [i].y + 16, 8, 8, 4, 1);
							} else if (malos [i].y > helmet.y + 8) {
								add_particle (malos [i].x + 16, malos [i].y - 8, 8, -8, 4, 1);
							} else {
								add_particle (malos [i].x + 16, malos [i].y + 8, 8, 0, 4, 1);
							}
						} else if (malos [i].x > helmet.x + 8) {
							if (malos [i].y < helmet.y) {
								add_particle (malos [i].x - 8, malos [i].y + 16, -8, 8, 4, 1);
							} else if (malos [i].y > helmet.y + 8) {
								add_particle (malos [i].x - 8, malos [i].y - 8, -8, -8, 4, 1);
							} else {
								add_particle (malos [i].x - 8, malos [i].y + 8, -8, 0, 4, 1);
							}
						} else {
							if (malos [i].y < helmet.y) {
								add_particle (malos [i].x + 8, malos [i].y + 16, 0, 8, 4, 1);
							} else if (malos [i].y > helmet.y + 8) {
								add_particle (malos [i].x + 8, malos [i].y - 8, 0, -8, 4, 1);
							}
						}
					}
				}				
				
				break;	
		}
	}
	
	// mover rollerfirer	
}

void move_helmet () {
	unsigned char xx, yy, cx, cy;
	unsigned char i;
	unsigned char prex = helmet.x >> 3;
	
	i = sp_JoyKeyboard (&keys);
		
	// Vertical
	
	cx = helmet.x >> 3;
	cy = helmet.y >> 3;
	xx = helmet.x >> 5;
	yy = helmet.y >> 5;
	
	if (flip_flop && helmet.vy < 4)
		helmet.vy = helmet.vy + 1;
		
	if (helmet.vy > 0) {	
		if ( (cy & 3) == 1 ) {
			if ( (cx & 3) <= 1) {
				if (cur_pant_buf [((yy+1)<<3) + xx] < 41) {
					helmet.vy = 0;
					helmet.y = (helmet.y >> 3) << 3;
				} else {
					helmet.y = helmet.y + helmet.vy;
				}	
			} else {
				if (cur_pant_buf [((yy+1)<<3) + xx] < 41 || cur_pant_buf [((yy+1)<<3) + xx + 1] < 41) {
					helmet.vy = 0;
					helmet.y = (helmet.y >> 3) << 3;
				} else {
					helmet.y = helmet.y + helmet.vy;
				}
			}
		} else {
			helmet.y = helmet.y + helmet.vy;
		}
	} else if (helmet.vy < 0) {
		if (helmet.y < -helmet.vy) helmet.vy = 0;
		if ( (cy & 3) == 0 ) {
			if ( (cx & 3) <= 1) {
				if (cur_pant_buf [((yy-1)<<3) + xx] < 41) {
					helmet.vy = 0;
					helmet.y = (helmet.y >> 3) << 3;
				} else {
					helmet.y = helmet.y + helmet.vy;
				}	
			} else {
				if (cur_pant_buf [((yy-1)<<3) + xx] < 41 || cur_pant_buf [((yy-1)<<3) + xx + 1] < 41) {
					helmet.vy = 0;
					helmet.y = (helmet.y >> 3) << 3;
				} else {
					helmet.y = helmet.y + helmet.vy;
				}
			}
		} else {
			helmet.y = helmet.y + helmet.vy;
		}		
	}
	
	if (helmet.y > 136) { 
		helmet.y = 136;
		helmet.vy = 0;
	}

	if (helmet.status) {
	
		cy = helmet.y >> 3;
		yy = helmet.y >> 5;
		
		if ( (i & sp_UP) == 0 ) {
			if ( (cy & 3) == 1 ) {
				if ( (cx & 3) <= 1 ) {
					if (cur_pant_buf [((yy+1) << 3) + xx] < 41) {
						helmet.x = (helmet.x >> 3) << 3;
						helmet.y = (helmet.y >> 3) << 3;
						helmet.vy = -8;	
						wyz_play_sound (8, CANAL_FX);
					}
				} else {
					if (cur_pant_buf [((yy+1) << 3) + xx] < 41 || cur_pant_buf [((yy+1) << 3) + xx + 1] < 41) {
						helmet.x = (helmet.x >> 3) << 3;
						helmet.y = (helmet.y >> 3) << 3;
						helmet.vy = -8;
						wyz_play_sound (8, CANAL_FX);
					}
				}
			}
		}
		
		if ( (i & sp_LEFT) == 0 && helmet.x > 0 ) {
			if ( (cx & 3) == 0 ) {
				if ( (cy & 3) <= 1) {
					if (cur_pant_buf [(yy << 3) + xx - 1] < 41) {
						helmet.x = (helmet.x >> 3) << 3;
						helmet.horz = 0;
					} else {
						helmet.x = helmet.x - helmet.vx;
						helmet.horz = 1;
					}
				} else {
					if (cur_pant_buf [(yy << 3) + xx - 1] < 41 || cur_pant_buf [((yy+1)<<3) + xx - 1] < 41) {
						helmet.x = (helmet.x >> 3) << 3;
						helmet.horz = 0;
					} else {
						helmet.x = helmet.x - helmet.vx;
						helmet.horz = 1;
					}
				}
			} else {
				helmet.x = helmet.x - helmet.vx;
			}
			
			if (prex != (helmet.x >> 3)) { helmet.ct = (helmet.ct + 1) & 3; }
			helmet.dir = 6;
		} else if ( (i & sp_RIGHT) == 0 && helmet.x < 200 ) {
			if ( (cx & 3) == 1 ) {
				if ( (cy & 3) <= 1) {
					if (cur_pant_buf [(yy << 3) + xx + 1] < 41) {
						helmet.x = (helmet.x >> 3) << 3;
						helmet.horz = 0;
					} else {
						helmet.x = helmet.x + helmet.vx;
						helmet.horz = 1;
					}
				} else {
					if (cur_pant_buf [(yy << 3) + xx + 1] < 41 || cur_pant_buf [((yy+1)<<3) + xx + 1] < 41) {
						helmet.x = (helmet.x >> 3) << 3;
						helmet.horz = 0;
					} else {
						helmet.x = helmet.x + helmet.vx;
						helmet.horz = 1;
					}
				}
			} else {
				helmet.x = helmet.x + helmet.vx;
			}
			
			if (prex != (helmet.x >> 3)) { helmet.ct = (helmet.ct + 1) & 3; }
			helmet.dir = 0;
		} else {
			helmet.horz = 0;
		}
		
		helmet.firestatus = 0;
		
		if ( (i & sp_FIRE) == 0 ) {
			
			if (fire_pressed == 0) {
				helmet.firestatus = 1;
				fire_pressed = 1;
				wyz_play_sound (0, CANAL_FX);
				if (helmet.dir == 0) {
					add_particle (helmet.x + 24, helmet.y + 8, 8, 0, helmet.power + 1, 1);
				} else {
					add_particle (helmet.x - 8, helmet.y + 8, -8, 0, helmet.power + 1, 1);
				}
			}
		} else {
			fire_pressed = 0;	
		}
		
				
		if (helmet.firestatus == 1)  {
			if (helmet.vy == 0)
				helmet.frame = helmet.dir + 3;
			else
				helmet.frame = helmet.dir + 5;
		} else {
			if (helmet.vy != 0) {
				helmet.frame = helmet.dir;
			} else {
				if (helmet.ct & 1)
					helmet.frame = 1;
				else
					helmet.frame = helmet.ct;
				helmet.frame += helmet.dir;
				
				if ( (i & sp_RIGHT) != 0 && (i & sp_LEFT) != 0 ) 
					helmet.frame = 1 + helmet.dir;
			}
		}
	}
}

void draw_scr (unsigned char n_pant) {
	// Cambiado para que lea de RAM3.
	// Se hace en dos pasadas: Primero se rellena cur_pant_buf 
	// y luego se pinta lo que haya en l.
	
	unsigned int pt;
	unsigned char x = 0, y = 0;
	unsigned char px = 0, py = 0;
	unsigned char i;
	
	host_x = host_y = 255;

	copy_screen (n_pant);
	
	px = 0, py = 0;
	for (i = 0; i < 35; i ++) {
		if (!cur_pant_buf [(py << 3) + px])
			cur_pant_buf [(py << 3) + px] = 78;
		else if (cur_pant_buf [(py<<3) + px] == 79) {
			host_x = (x + 1) << 3; 
			host_y = (y + 1) << 3;	
		}

		csp2_Draw_SuperTile (x, y, cur_pant_buf [(py<<3) + px]);

		x += 4; px ++;
		if (x == 28) {
			x = 0;
			y += 4;
		}
		if (px == 7) {
			px = 0;
			py ++;
		}	
	}
}

unsigned int level_x_address [] = {
	53307, 53695, 54125, 54545
};

void main (void) {
	unsigned char i, j, x, y;
	unsigned char pcx, pcy, pcoldx, pcoldy;
	unsigned char *allpurposepuntero;
	unsigned int idx;
	struct sp_Rect rectangulo;
	unsigned char n_pant;
	char updatehelmet = 1;
	char respawn;
	char level, gameover, playthegame, finalpant, n_hostages;
	int key0, key1;
	
	// Substitute BASICs ISR for this thingo: */
	play = 0;
	#asm
		di
	#endasm

	sp_InitIM2(0xf1f1);						// Does nothing :)
	sp_CreateGenericISR(0xf1f1);
	sp_RegisterHook(255, ISR);			// Registramos el hook - Gracias Utopian!

	#asm
		ei
	#endasm
	
	play = 1;
	
	// Initialization stuff
	sp_Initialize (7, 245);
	sp_Border (BLACK);

	srand (100);
		
	keys.up    = sp_LookupKey('q');
	keys.down  = sp_LookupKey('a');
	keys.left  = sp_LookupKey('o');
	keys.right = sp_LookupKey('p');
	keys.fire  = sp_LookupKey(' ');
	
	key0 = sp_LookupKey ('0');
	key1 = sp_LookupKey ('1');

	// Tileset enable:
	
	allpurposepuntero = gfx0;
	for (idx = 0; idx <= 255; idx++) {
		sp_TileArray (idx, allpurposepuntero);
		allpurposepuntero += 8;
	}
	
	// Clip structure
	spritesClipValues.row_coord = 0;
	spritesClipValues.col_coord = 0;
	spritesClipValues.height = 24;
	spritesClipValues.width = 32;
	spritesClip = &spritesClipValues;

	// Seleccionar ula64/normal
	unpack_RAM3 (59678);
	wyz_play_sound (3, CANAL_FX);
	
	ula64 = 2;
	while (ula64 == 2) {
		if (sp_KeyPressed (key0))
			ula64 = 0;
		if (sp_KeyPressed (key1))
			ula64 = 1;
	}
	
	// "Clear buf" (ha ha ha)
	while(sp_GetKey());
	
	// INTRO
	unpack_RAM3 (58352);
	wyz_play_sound (7, CANAL_FX);
	espera_activa (200);
	fade_out ();
	unpack_RAM3 (58475);
	wyz_play_sound (7, CANAL_FX);
	espera_activa (200);
	fade_out ();
	
	while (1) {
		// MENU
		
		unpack_RAM3 (54969);
		wyz_play_music (0);
		while (!sp_GetKey ());
		wyz_stop_sound ();
		fade_out ();
	
		helmet.score = 0;
		level = 1;
		gameover = 0;
		helmet.lives = 4;
			
		// Init hostages
		
		init_hostages ();	
		
		while (level < 5 && !gameover) {
			
			// Una vida ms, pero mximo 4.
			
			helmet.lives ++;
			if (helmet.lives > 4)
				helmet.lives = 4;
			
			unpack_RAM3 (level_x_address [level - 1]);
			
			wyz_play_music (1);
			espera_activa (500);
			wyz_stop_sound ();
			fade_out ();
			
			n_pant = (level - 1) * 25;
			finalpant = n_pant + 24;
			
			helmet.x = 32;
			helmet.y = 0;
			helmet.vx = 4;
			helmet.vy = 0;
			//helmet.power = 0;			// Para pistola empepinada poner a 1
			
			helmet.life = 100;
			helmet.status = 1;			// Si status != 1, helmet est muerto
			respawn = 0;
			n_hostages = 0;
			
			sp_UpdateNow ();
			unpack_RAM3 (52652);
			
			draw_score (helmet.score);
			draw_lives (helmet.lives);
			draw_life (helmet.life);
			
			playthegame = 1;
			
			if (level == 1 || level == 3) 
				wyz_play_music (4);
			else
				wyz_play_music (5);
				
			do {
				helmet.oldx = helmet.x;
				helmet.oldy = helmet.y;
				helmet.frame = 0;
				
				draw_scr (n_pant);
				
				// Init player
				rectangulo.height = rectangulo.width = 3;
				rectangulo.row_coord = Y_OFFSET + (helmet.y>>3);
				rectangulo.col_coord = X_OFFSET + (helmet.x>>3);
				sp_GetTiles (&rectangulo, helmet_buffer);
				
				init_particles ();	
				init_malos ();
				
				do {		
					// Para que todo vaya ms rpido y controle bien los borrados
					// y actualizaciones, voy a montar un pifostio en el bucle principal que no
					// va a ser ni normal. Es una putada porque tena el cdigo superbonito
					// y ahora va a quedar mezcladote y feo. Comentar profusamente.
					
					// 1: flipear el flipflop para contar de 0.5 en 0.5 :D
					
					flip_flop = !flip_flop;
					
					// 4: muevo todos los enemigos
					
					move_malos ();
					
					// 5: muevo al Sargento Helmet
					
					move_helmet ();
					
					if (!helmet.status) {
						helmet.ct --;
						if (helmet.ct == 0) {
							helmet.status = 1;	
							if (respawn) {
								respawn = 0;
								helmet.y = 0;
								helmet.x = (helmet.x >> 5) << 5;	// Ajusto (HU!) a tile.
								while (cur_pant_buf [((helmet.y >> 5) << 3) + (helmet.x >> 5)] < 41) {
									helmet.y += 32;
								}
								helmet.vy = 0;	
							}
						}
					}
					
					// 6: Borramos los enemigos:
		
					for (i = 0; i < 4; i ++) 			
						if (malos [i].vida > 0 || malos [i].tipo == 1) {
							rectangulo.height = rectangulo.width = 2;
							rectangulo.row_coord = Y_OFFSET + (malos [i].oldy >> 3);
							rectangulo.col_coord = X_OFFSET + (malos [i].oldx >> 3);
							sp_PutTiles (&rectangulo, flyingbads_buffer + (i << 3));
							sp_Invalidate (&rectangulo, &rectangulo);
						}
					
					// 3: muevo todas las partculas (Borrando la posicin actual antes).
					
					update_particles ();
						
					// 7: Borramos a helmet:
					
					pcx = helmet.x >> 3;
					pcy = helmet.y >> 3;
					pcoldx = helmet.oldx >> 3;
					pcoldy = helmet.oldy >> 3;
					
					updatehelmet = 1;
					
					if (updatehelmet) {
						rectangulo.height = rectangulo.width = 3;
						rectangulo.row_coord = Y_OFFSET + (pcoldy);
						rectangulo.col_coord = X_OFFSET + (pcoldx);
						sp_PutTiles (&rectangulo, helmet_buffer);
						sp_Invalidate (&rectangulo, &rectangulo);
					}
					
					// Rescatar un hostage
					
					if (helmet.status) {
						if (host_x >= helmet.x - 8 && host_x <= helmet.x + 16 && host_y >= helmet.y - 16 && host_y <= helmet.y + 16) {
							helmet.score += 50;
							draw_score (helmet.score);	
							/*// Le rellenamos la vida a helmet
							helmet.life = 100;
							draw_life (helmet.life);*/
							n_hostages ++;
							csp2_Draw_SuperTile ((host_x >> 3) - 1, (host_y >> 3) - 1, 78);
							elimina_hostage (n_pant);
							host_x = host_y = 255;
							wyz_play_sound (3, CANAL_FX);
						}
					}
					
					// Coger una L [una L es un enemigo con vida == 0 y tipo == 1]
					
					for (i = 0; i < 4; i ++) 
						if (malos [i].vida == 0 && malos [i].tipo == 1) {
							// Es una L, vemos si colisiona con Mr Helmet
							if (malos [i].x >= helmet.x - 8 && malos [i].x <= helmet.x + 16 && malos [i].y >= helmet.y - 8 && malos [i].y <= helmet.y + 16)	{
								// Nos cargamos del todo el malo:
								malos [i].tipo = 0;
								// Le rellenamos la vida a helmet
								helmet.life = 100;
								draw_life (helmet.life);
								// Y le damos puntos
								helmet.score += 25;	
								draw_score (helmet.score);
								// Y adems no se pintar. Jue jue jue, me encanta ajorr cdigo.
								wyz_play_sound (3, CANAL_FX);
							}
						}
										
					// 8: Tomar nuevo fondo enemigos:
					
					for (i = 0; i < 4; i ++) 			
						if (malos [i].vida > 0 || malos.tipo == 1) {
							rectangulo.height = rectangulo.width = 2;
							rectangulo.row_coord = Y_OFFSET + (malos [i].y >> 3);
							rectangulo.col_coord = X_OFFSET + (malos [i].x >> 3);
							sp_GetTiles (&rectangulo, flyingbads_buffer + (i << 3));
						}
					
					// 9: Tomar nuevo fondo helmet:
					
					if (updatehelmet) {
						rectangulo.height = rectangulo.width = 3;
						rectangulo.row_coord = Y_OFFSET + (pcy);
						rectangulo.col_coord = X_OFFSET + (pcx);
						sp_GetTiles (&rectangulo, helmet_buffer);
					}
		
					// 10: Pintar a los enemigos:
					
					for (i = 0; i < 4; i ++)  {
						if (malos [i].vida > 0) {
							csp2_Draw_2x2_Sprite (malos [i].x >> 3, malos [i].y >> 3, malos [i].frame);
							malos [i].oldx = malos [i].x;
							malos [i].oldy = malos [i].y;
						} else if (malos [i].tipo == 1) {
							csp2_Draw_2x2_Sprite (malos [i].x >> 3, malos [i].y >> 3, 8);
						}
					}
								
					// 11: Pintar a helmet:
					
					if (updatehelmet) {
						csp2_Draw_3x3_Sprite (pcx, pcy, helmet.frame);
						helmet.oldy = helmet.y; helmet.oldx = helmet.x;
					}
		
					// 12: Pintar partculas.
					
					for (i = 0; i < MAX_PARTICLES; i ++) {
						if ((particulas [i].y >> 3) < 20) {
							switch (particulas [i].tipo) {
								case 1:
									sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), 5, (particulas [i].vx < 0)?127:126 );	
									break;
								case 2:
									sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), 86, 125 );	
									break;
								case 3:
									sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), ((rand() & 7)<4)?6:7, ((rand () & 7)<4)?62:63 );	
									break;
								case 4:	
									sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), 6, 125 );	
									break;
								case 5:
									sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), clrexpls[rand () & 3], 125 - particulas [i].vida );	
									break;
							}
						}
					}
					
					// Update display
					
					sp_UpdateNow ();
					
					// Lgica de "Exit screen"
					
					i = sp_JoyKeyboard (&keys);
					if (helmet.x == 0 && (i & sp_LEFT) == 0) {
						helmet.x = 200;
						n_pant --;
						break;
					} else if (helmet.x == 200 && (i & sp_RIGHT) == 0) {
						helmet.x = 0;
						n_pant ++;
						break;
					}
					
					// Morir en un pit
					
					if (helmet.y >= 136) {
						if (helmet.status) {
							if (helmet.lives > 0) {
								helmet.life = 100;
								helmet.lives --;
							} else {
								helmet.life = 0;
							}
								
							draw_lives (helmet.lives);
							draw_life (helmet.life);
							helmet.status = 0;
							helmet.ct = 75;
							helmet.frame = helmet.dir + 4;
							respawn = 1;
						} else {
							respawn = 1;	
						}
					}
					
					// Lgica estoy muelto.					
				
					if (helmet.status)
						if (helmet.lives == 0 && helmet.life == 0) {
							gameover = 1;
							playthegame = 0;
							break;
						}
					
					// Lgica de fin de fase
					
					if (helmet.status)
						if (helmet.x >= 160 && n_pant == finalpant && n_hostages == 10) {
							playthegame = 0;
							level ++;
							break;	
						}
		
				} while (1);
			} while (playthegame);
		}
		
		wyz_stop_sound ();
		fade_out ();
		
		// Pintar carteln gameover
		if (gameover) {
			unpack_RAM3 (56308);
			wyz_play_music (2);
			espera_activa (500);
			wyz_stop_sound ();
			fade_out ();
		}
		
		// Pintar carteln ending
		if (level == 5) {
			unpack_RAM3 (57101);
			wyz_play_music (3);
			while (!sp_GetKey ());
			wyz_stop_sound ();
			fade_out ();
		}		
	}
}

