// Particles

#define MAX_PARTICLES 64

typedef struct {
	unsigned char x;
	unsigned char y;
	char vx;
	char vy;
	char tipo;
	char vida;
} PARTICLE;

PARTICLE particulas [MAX_PARTICLES];

char clrexpls [4] = {2, 6, 7, 3};

void init_particles () {
	unsigned char i;	
	
	for (i = 0; i < MAX_PARTICLES; i ++) {
		particulas [i].tipo = 0;
	}
}

void add_particle (unsigned char x, unsigned char y, char vx, char vy, char tipo, char vida) {
	unsigned char i;
	
	if (x < 224 && y < 160)
		for (i = 0; i < MAX_PARTICLES; i ++) {
			if (particulas [i].tipo == 0) {
				particulas [i].x = (x>>3)<<3;	// Ajuste a celda de carcter.
				particulas [i].y = (y>>3)<<3;
				particulas [i].vx = vx;
				particulas [i].vy = vy;
				particulas [i].tipo = tipo;
				particulas [i].vida = vida;
				break;
			}
		}
}

void destroy_particle (unsigned char i) {
	particulas [i].tipo = 0;
}

void update_particles () {
	unsigned char i, j, o;
	unsigned char cx, cy, xx, yy;
	unsigned char px, py, mx, my;
	unsigned char flag;
	
	for (i = 0; i < MAX_PARTICLES; i ++) {
		if (particulas [i].tipo != 0) {
			
			// Delete oldpos
			csp2_Restore_At (particulas [i].x >> 3, particulas [i].y >> 3);
			
			switch (particulas [i].tipo) {
				
				// Disparo normal
				// Disparo redondo multi-direccin
				
				case 1:	
				case 4:
					particulas [i].x += particulas [i].vx;
					if (particulas [i].tipo == 4)
						particulas [i].y += particulas [i].vy;
										
					// Collision with backdrop
					flag = 0;
					
					if (cur_pant_buf [(particulas [i].x >> 5) + ((particulas [i].y >> 5) << 3)] < 41) {
						flag = 1;
					}
					
					// Out of screen
					if (particulas [i].x >= 216 || particulas [i].x <= 8 || (particulas [i].y <= 8 && particulas [i].tipo == 4) || particulas [i].y > 160) {
						particulas [i].tipo = 0;
					}						
					
					if (flag == 1) {
						particulas [i].tipo = 0;	
						add_particle ( particulas [i].x + (rand() & 15) - 4 - particulas [i].vx, (particulas [i].y + (rand() & 15) - 8), 0, 0, 3, 4 + (rand () & 8) );
						add_particle ( particulas [i].x + (rand() & 15) - 4 - particulas [i].vx, (particulas [i].y + (rand() & 15) - 8), 0, 0, 3, 4 + (rand () & 8) );
					}
					
					// Collision 
					// Con enemigo:
					px = particulas [i].x >> 3;
					py = particulas [i].y >> 3;
					
					for (j = 0; j < 4; j ++) {
						if (malos [j].vida > 0) {
							mx = malos [j].x >> 3;
							my = malos [j].y >> 3;
							
							if ((px == mx || px == mx + 1) && (py == my || py == my + 1)) {
								// Romper enemigo y crear explosiones
								malos [j].vida --;
								helmet.score ++;
								wyz_play_sound (1, CANAL_FX);
								if (malos [j].vida > 0) {
									add_particle ( particulas [i].x, particulas [i].y, 0, 0, 3, 4 + (rand () & 8) );
									if (malos [j].tipo != 1) {
										malos [j].x += particulas [i].vx ;
										if (malos [j].x >= 208) malos [j].x = 208;
										cx = malos [j].x >> 3;
										cy = malos [j].y >> 3;
										xx = malos [j].x >> 5;
										yy = malos [j].y >> 5;
										o = 0;
										
										if ((cy & 3) == 3) {
											if ((cx & 3) == 3) {
												o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
													cur_pant_buf [(yy<<3) + xx + 1] < 41 ||
													cur_pant_buf [((yy + 1)<<3) + xx] < 41 ||
													cur_pant_buf [((yy + 1)<<3) + xx + 1] < 41);
											} else {
												o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
													cur_pant_buf [((yy + 1)<<3) + xx] < 41);
											}
										} else {
											if ((cx & 3) == 3) {
												o = (cur_pant_buf [(yy<<3) + xx] < 41 ||
													cur_pant_buf [(yy<<3) + xx + 1] < 41);
											} 
										}
										
										if (o) {
											malos [j].x = malos [j].oldx;
											malos [j].y = malos [j].oldy;
										}
									}
								} else {
									wyz_play_sound (5, CANAL_FX);
									add_particle ( mx << 3, my << 3, 0, 0, 5, 1 + rand () % 6 );
									add_particle ( 8 + (mx << 3), my << 3, 0, 0, 5, 1 + rand () % 6 );
									add_particle ( mx << 3, 8 + (my << 3), 0, 0, 5, 1 + rand () % 6 );
									add_particle ( 8 + (mx << 3), 8 + (my << 3), 0, 0, 5, 1 + rand () % 6 );
									helmet.score += 10;
								}
								particulas [i].tipo = 0;
								draw_score (helmet.score);
								break;
							}
						}
					}
					
					// Con helmet:
					
					mx = helmet.x >> 3;
					my = helmet.y >> 3;
					if (px >= mx && px <= mx + 2 && py >= my && py <= my + 2) {
						helmet_resta_vida ();
						wyz_play_sound (0, CANAL_FX);
						// Los caones quitan el doble:
						if (particulas [i].tipo == 1)
							helmet_resta_vida ();
						particulas [i].tipo = 0;
						break;	
					}
					
					// Draw particle
					/*
					if (particulas [i].tipo == 1) {
						sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), 5, (particulas [i].vx < 0)?127:126 );	
					} else if (particulas [i].tipo == 4) {
						sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), 6, 125 );	
					}
					*/
										
					break;
					
				// Disparo power: No se destruye al colisionar
					
				case 2:
					particulas [i].x += particulas [i].vx;
											
					// Out of screen
					if (particulas [i].x >= 216 || particulas [i] <= 0) {
						particulas [i].tipo = 0;
					}
					
					// Collision with baddie
					
					
					// Draw particle
					/*
					if (particulas [i].tipo != 0) {
						sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), 86, 125 );	
					}
					*/
										
					break;
					
				// Chispazo:
					
				case 3:
				case 5:
					particulas [i].vida --;
					
					// Die
					if (particulas [i].vida == 0)
						particulas [i].tipo = 0;
					
					// Draw
					/*
					if (particulas [i].tipo != 0) {
						sp_PrintAtInv (Y_OFFSET + (particulas [i].y >> 3), X_OFFSET + (particulas [i].x >> 3), ((rand() & 7)<4)?6:7, ((rand () & 7)<4)?62:63 );	
					}
					*/
									
					break;				
			}
		}	
	}	
}
